# Interface MathTransform2D

All Superinterfaces:
  `MathTransform`

All Known Implementing Classes:
  `AbstractMathTransform2D, AbstractMathTransform2D​.Inverse, PoleRotation`

public interface MathTransform2D extends MathTransform
Transforms two-dimensional coordinate points. `CoordinateOperation​.getMathTransform()` may returns instance of this interface when source and destination coordinate systems are both two dimensional. `MathTransform2D` extends `MathTransform` by adding some methods for easier inter-operability with Java2D.

If the transformation is affine, then `MathTransform` shall be an immutable instance of `AffineTransform`.

Since:
  1.0

- ## Method Summary

  Modifier and Type
  Method
  Description
  `Shape`
  `createTransformedShape(Shape shape)`
  Transforms the specified shape.
  `Matrix`
  `derivative(Point2D point)`
  Gets the derivative of this transform at a point.
  `MathTransform2D`
  `inverse()`
  Creates the inverse transform of this object.
  `Point2D`
  `transform(Point2D ptSrc, Point2D ptDst)`
  Transforms the specified `ptSrc` and stores the result in `ptDst`.

  ### Methods inherited from interface MathTransform

  `derivative, getSourceDimensions, getTargetDimensions, isIdentity, toWKT, transform, transform, transform, transform, transform`

- ## Method Details

  - ### transform

    Point2D transform(Point2D ptSrc, Point2D ptDst) throws TransformException
    Transforms the specified `ptSrc` and stores the result in `ptDst`. If `ptDst` is `null`, a new `Point2D` object is allocated and then the result of the transformation is stored in this object. In either case, `ptDst`, which contains the transformed point, is returned for convenience. If `ptSrc` and `ptDst` are the same object, the input point is correctly overwritten with the transformed point.
    Parameters:
      `ptSrc` - the coordinate point to be transformed.
      `ptDst` - the coordinate point that stores the result of transforming `ptSrc`, or `null` if a new point shall be created.
    Returns:
      the coordinate point after transforming `ptSrc` and storing the result in `ptDst` or in a new point if `ptDst` was null.
    Throws:
      `TransformException` - if the point cannot be transformed.

  - ### createTransformedShape

    Shape createTransformedShape(Shape shape) throws TransformException
    Transforms the specified shape. This method may replace straight lines by quadratic curves when applicable. It may also do the opposite (replace curves by straight lines). The returned shape doesn't need to have the same number of points than the original shape.
    Parameters:
      `shape` - The Shape to transform.
    Returns:
      The transformed shape. Some implementations may returns `shape` unmodified if this transform is identity.
    Throws:
      `TransformException` - if a transform failed.

  - ### derivative

    Matrix derivative(Point2D point) throws TransformException
    Gets the derivative of this transform at a point. The derivative is the matrix of the non-translating portion of the approximate affine map at the point.
    Parameters:
      `point` - The coordinate point where to evaluate the derivative. Null value is accepted only if the derivative is the same everywhere. For example affine transform accept null value since they produces identical derivative no matter the coordinate value. But most map projection will requires a non-null value.
    Returns:
      The derivative at the specified point as a 2×2 matrix. This method never returns an internal object: changing the matrix will not change the state of this math transform.
    Throws:
      `NullPointerException` - if the derivative dependents on coordinate and `point` is `null`.
      `TransformException` - if the derivative cannot be evaluated at the specified point.

  - ### inverse

    MathTransform2D inverse() throws NoninvertibleTransformException
    Creates the inverse transform of this object.
    Specified by:
      `inverse` in interface `MathTransform`
    Returns:
      The inverse transform.
    Throws:
      `NoninvertibleTransformException` - if the transform cannot be inverted.
    Since:
      2.2